import sys
import numpy as np
import cv2

n = len( sys.argv )
if n != 2 :
	print( "Args: nombre_imagen" )
	sys.exit(1)

nombre = sys.argv[1]

img1 = cv2.imread( nombre, cv2.IMREAD_GRAYSCALE )
print( img1.shape )

# cv2.imshow( "Imagen de entrada", img1 )
# cv2.waitKey(0)

# Vamos a procesar la imagen de entrada
# Este es el suavizado
img2 = cv2.GaussianBlur( img1, (7,7), 0 )
# cv2.imwrite( "suavizada.png", img2 )

# La binarizamos
ret, img3 = cv2.threshold( img2, 30, 255, cv2.THRESH_BINARY_INV )
cv2.imwrite( "binarizada.png", img3 )

# Le aplicamos la operación morfológica abriendo,
# que es una erosión seguida de una dilatación

# element = cv2.getStructuringElement( cv2.MORPH_RECT, (3, 3) )
# element = cv2.getStructuringElement( cv2.MORPH_CROSS, (3, 3) )
element = cv2.getStructuringElement( cv2.MORPH_ELLIPSE, (3, 3) )

#cv2.morphologyEx( Image2, cv2.MORPH_ERODE, element, Image2, (-1,-1), 2 )
img4 = cv2.morphologyEx( img3, cv2.MORPH_ERODE, element )
img5 = cv2.morphologyEx( img4, cv2.MORPH_DILATE, element )

cv2.imwrite( "abierta.png", img5 )
